<?php


class ct_fields
{
	var $ct_type;
	var $ct_field_name;
	var $ct_field_label;
	var $ct_field_type ;
	var $ct_field_desc ;
	var $ct_field_val ;
   
	
	function ct_fields($taxonomy,$name,$label,$type,$desc,$val)
	{

		$this->ct_type = $taxonomy;
		$this->ct_field_name = $name;
		$this->ct_field_label = $label;
		$this->ct_field_type = $type;
		$this->ct_field_desc = $desc;
		$this->ct_field_val = $val;
		add_action ( $this->ct_type.'_add_form_fields', array($this, 'field_input_metabox'));
		add_action ( $this->ct_type.'_edit_form_fields', array($this, 'field_input_metabox'));
		add_action ( 'edited_'.$this->ct_type, array($this, 'save_field_data' ));
		add_action ( 'created_'.$this->ct_type, array($this, 'save_field_data' ));
        
       
        add_shortcode('xy_'.$this->ct_type, array($this,'xydac_shortcode'));

        add_filter('manage_edit-'.$this->ct_type.'_columns', array($this,'taxonomy_columns'));
	    add_filter('manage_'.$this->ct_type.'_custom_column', array($this,'taxonomy_columns_manage'),10,3);


        
	}


    function find_label($name)
    {
        global $wpdb;
        $table = $wpdb->prefix.'taxonomyfield';
        return $wpdb->get_row("SELECT field_label FROM $table WHERE field_name='$name' limit 1")->field_label;
    }
    function xydac_shortcode($atts)
    {
        global $post;
	    extract(shortcode_atts(array(
		'field' => '',
	     ), $atts));
        $a = wp_get_object_terms($post->ID, $this->ct_type);
        foreach($a as $v)
		{
		$d = get_metadata("taxonomy", $v->term_id, $field , TRUE);
		}

        if(is_array($d))
        {   $e='';
            foreach ($d as $k=>$v)
            {
                foreach($v as $j)
                    $e .= "<strong>".$this->find_label($k)."</strong> : ".$j.", ";
            }
            $d = $e;
        }
            if(substr($d,-2)==', ')
                return substr($d,0,-2);
            else
                return $d;
	
    }


	public function field_input_metabox($tag) {
	$xy_meta = get_metadata('taxonomy', $tag->term_id, $this->ct_field_name, TRUE);



    if(!isset($_GET['action'])){?>
    <div class="form-field">
        <label for="<?php _e($this->ct_field_name) ?>"><?php _e($this->ct_field_label) ?></label>
        <?php if($this->ct_field_type == 'text'){ ?>
            <input type="text" name="<?php _e($this->ct_field_name) ?>" id="<?php _e($this->ct_field_name) ?>" value="<?php echo $xy_meta; ?>" size="40"/>
        <?php } else { $p_values = explode(',',$this->ct_field_val); ?>
            <select name="<?php _e($this->ct_field_name) ?>" id="<?php _e($this->ct_field_name) ?>">
                <?php foreach($p_values as $p_value) { $p_value = trim($p_value); ?>
                    <option value="<?php _e($p_value) ?>" <?php if($xy_meta==$p_value) _e('Selected'); ?>><?php _e($p_value) ?></option>
                <?php } ?>
            </select>
        <?php } ?>
        <p class="description"><?php _e($this->ct_field_desc) ?></p>
    </div>
    <?php }else { ?>
	<tr class="form-field">
		<th scope="row" valign="top">
			<label for="<?php _e($this->ct_field_name) ?>"><?php _e($this->ct_field_label) ?></label>
		</th>
		<td>
            <?php if($this->ct_field_type == 'text'){  ?>
			    <input type="text" name="<?php _e($this->ct_field_name) ?>" id="<?php _e($this->ct_field_name) ?>" value="<?php echo $xy_meta; ?>" size="40"/><br />
            <?php } else { $p_values = explode(',',$this->ct_field_val); ?>
                <select name="<?php _e($this->ct_field_name) ?>" id="<?php _e($this->ct_field_name) ?>">
                     <?php foreach($p_values as $p_value) { $p_value = trim($p_value);  ?>
                        <option value="<?php _e($p_value)  ?>" <?php if($xy_meta==$p_value) _e('Selected'); ?>><?php _e($p_value) ?></option>
                    <?php } ?>
                </select>
            <?php } ?>
			<p class="description"><?php _e($this->ct_field_desc) ?></p>
		</td>
	</tr>

		<?php }
	}
	public function save_field_data($term_id) {
        if (isset($_POST[$this->ct_field_name]) ) {
	        $ct_value = esc_attr($_POST[$this->ct_field_name]);
	        update_metadata('taxonomy', $term_id, $this->ct_field_name, $ct_value);
        }
	}


    function taxonomy_columns($columns) {
        $columns[$this->ct_field_name] = __( $this->ct_field_label, 'xydac' );
        return $columns;
    }


    function taxonomy_columns_manage( $r ,$column_name, $term) {
        if ($column_name !=$this->ct_field_name)
            return;

        $val =  get_metadata('taxonomy', $term, $this->ct_field_name, TRUE);
        if ( !$val )
		    $val = '<em>' . __( 'undefined', 'xydac' ) . '</em>';

	    echo $val;
    }

}
?>