<?php
/**
 * @package UltimateTaxonomyManager
 * @version 1.0
 */
/*
Plugin Name: Ultimate Taxonomy Manager
Plugin URI: http://taxonomymanager.wordpress.com/
Description: Manage All your Taxonomy and Custom Taxonomy fields with ease using this plugin.
Author: XYDAC
Version: 1.0
Author URI: http://xydac.wordpress.com/
License: GPL2
*/
/*  Copyright 2010  deepak.seth  (email : indk@ymail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
define('XYDAC_HOME_PATH',get_bloginfo('wpurl')."/wp-admin/options-general.php?page=ultimate-taxonomy-manager&sub=home");
define('XYDAC_TAXONOMY_PATH',get_bloginfo('wpurl')."/wp-admin/options-general.php?page=ultimate-taxonomy-manager&sub=custom-taxonomy");
define('XYDAC_FIELDS_PATH',get_bloginfo('wpurl')."/wp-admin/options-general.php?page=ultimate-taxonomy-manager&sub=custom-taxonomy-fields");
define('XYDAC_FIELDTABLE',$wpdb->prefix.'taxonomyfield');
include "ct.class.php";
include 'field.php';
include "taxonomy.php";
//---action,filter etc
register_activation_hook(__FILE__,'xydac_setup');
add_action( 'init', 'xydac_init' );
add_action( 'admin_menu', 'xydac_menu');
add_action( 'admin_menu', 'xydac_meta_boxes');
//add_action( 'admin_head', 'xydac_taxonomy_javascript');
//----functions
function xydac_setup() {
	global $wpdb;
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    $charset_collate = '';  
	if (!empty ($wpdb->charset))
		$charset_collate = "DEFAULT CHARACTER SET {$wpdb->charset}";
	if (!empty ($wpdb->collate))
		$charset_collate .= " COLLATE {$wpdb->collate}";
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}taxonomyfield (
			field_id bigint(20) NOT NULL AUTO_INCREMENT,
			tax_name varchar(255) NOT NULL,
			field_name varchar(255) DEFAULT NULL,
			field_label varchar(255) DEFAULT NULL,
			field_type varchar(255) DEFAULT NULL,
			field_desc longtext DEFAULT NULL,
			field_val longtext DEFAULT NULL,
			PRIMARY KEY (field_id)
		) $charset_collate;";
	$wpdb->query($sql);$sql='';
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}taxonomymeta (
		  meta_id bigint(20) unsigned NOT NULL auto_increment,
		  taxonomy_id bigint(20) unsigned NOT NULL default '0',
		  meta_key varchar(255) default NULL,
		  meta_value longtext,
		  PRIMARY KEY  (meta_id),
		  KEY taxonomy_id (taxonomy_id),
		  KEY meta_key (meta_key)
		) $charset_collate;";
	$wpdb->query($sql);
}

function xydac_init()
{
global $wpdb;
$wpdb->taxonomymeta = "{$wpdb->prefix}taxonomymeta";
//Register Taxonomies 
xydac_reg_taxonomies();
//Register all fields
$ct_rows = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}taxonomyfield ");
    foreach($ct_rows as $ct_row)//for each field
	{
		$ss = new ct_fields($ct_row->tax_name,$ct_row->field_name,$ct_row->field_label,$ct_row->field_type,$ct_row->field_desc,$ct_row->field_val);
	}
    //register_taxonomy_for_object_type('category', 'attachment');
     //add_post_type_support('attachment', 'category');
}
function xydac_path( $file ) {
    return trailingslashit( dirname( $file ) );
}
//---xydac_taxonomy page
/*
 * Creates the tab for main page
 * param $page=home :if home is active tab
 * param $page=taxonomy :if custom taxonomies is active tab
 * param $page=fields :if Custom Taxonomy Fields is active tab
 */
function xydac_heading($page="home"){ ?>
    <div id="icon-options-general" class="icon32"><br></div>
    <h2 style="border-bottom: 1px solid #CCC;padding-bottom:0px;">
        <a href="<?php _e(XYDAC_HOME_PATH,'xydac') ?>" class="nav-tab <?php if($page=='home')  _e('nav-tab-active','xydac') ?>">Home</a>
        <a href="<?php _e(XYDAC_TAXONOMY_PATH,'xydac') ?>" class="nav-tab <?php if($page=='taxonomy')  _e('nav-tab-active','xydac') ?>">Custom Taxonomies</a>
        <a href="<?php _e(XYDAC_FIELDS_PATH,'xydac') ?>" class="nav-tab <?php if($page=='fields')  _e('nav-tab-active','xydac') ?>">Custom Taxonomy Fields</a>
    </h2> <br class="clear" />
    <?php
}
function xydac_home_aboutus(){
    ?>
    <div class="postbox opened">
                    <h3>About This Plugin</h3>
                    <div class="inside">
                       <table class="form-table">
                           <tbody>
                            <tr>
                               <th scope="row" valign="top"><b>Plugin Version</b></th>
                               <td>1.0</td>
                           </tr>
                            <tr>
                               <th scope="row" valign="top"><b>Author</b></th>
                               <td>XYDAC</td>
                           </tr>
                           <tr>
                               <th scope="row" valign="top"><b>Like this plugin?</b></th>
                               <td>You can check out the following for more info
                                   <br>&nbsp;&bull;&nbsp;Check Out the <a href="http://taxonomymanager.wordpress.com/">Plugin Homepage</a>.
                                   <br>&nbsp;&bull;&nbsp;Rate the Plugin on <a href="http://wordpress.org/extend/plugins/ultimate-taxonomy-manager/">WordPress.org</a>.
                                   <br>&nbsp;&bull;&nbsp;<span style="color:red;background:yellow;padding:4px;font-weight:bold;">Support further development with a <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=nikhilseth1989%40gmail%2ecom&item_name=WordPress%20Plugin%20(Ultimate%20Taxonomy%20Manager)&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8">Donation</a></span>.
                                   <br>
                                   </td>
                           </tr>
                           <tr>
                               <th scope="row" valign="top"><b>Need further support?</b></th>
                               <td>If you have any problems or some great ideas to improve plugin, please let me know on the <a href="http://taxonomymanager.wordpress.com/">Plugin Homepage</a>.<br></td>
                           </tr>

                           </tbody>
                       </table>
                        <form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post">
                        <input type="hidden" name="cmd" value="_donations">
                        <input type="hidden" name="business" value="nikhilseth1989@gmail.com">
                        <input type="hidden" name="item_name" value="Taxonomy Manager">
                        <input type="hidden" name="currency_code" value="USD">
                        <input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Donate for Taxonomy Manager!">
                        </form>
                    </div>
    <?php


}
function xydac_home()
{ ?>
        <div class="wrap" ><?php xydac_heading(); ?>
            <div id="poststuff" class="ui-sortable">
                <div class="postbox opened">
                    <h3>Information</h3>
                    <div class="inside">
                       <p>This plugin is an Easy to use Taxonomy Manager to Customize Taxonomies and its Custom Fields.</p>
                        <p>You can use the above menus to create <strong>Custom Taxonomies</strong> as well as Create <strong>Custom Fields</strong> to store more information
                           about your Taxonomies.</p>
                        <h4>Custom Taxonomies : </h4>
                            <p>&bull;&nbsp;All fields except name and post types are optional in Create Taxonomy form.<br/>
                            &bull;&nbsp;When you delete a Taxonomy then the data Taxonomy has saved does not get removed, So if you want to use the Taxonomy again just recreate it again with same name.<br/>
                                
                            </p>
                        <h4>Custom Fields : </h4>
                            <p>&bull;&nbsp;You can create custom fields for any taxonomy except Media types.<br/>
                            &bull;&nbsp;To display Custom Fields in the posts you can use shortcode <strong>[xy_<em>{name of taxonomy}</em>]</strong> where {name of taxonomy} is the Name of Taxonomy.<br/>
                                &bull;&nbsp;Advanced use of Short Code : <strong>[xy_<em>{name of taxonomy}</em> field="<em>{field name}</em>"]</strong> can be used to display value of Custom Field of Taxonomy.<br/>

                            </p>
                    </div>
                </div>
                <?php xydac_home_aboutus(); ?>
                
                </div>

            </div>
        </div>
  <?php
}
function xydac_menu() {
  add_options_page('Taxonomy Manager', 'Taxonomy Manager', 'manage_options', 'ultimate-taxonomy-manager', 'xydac_menu_manager');
}


function xydac_menu_manager() {

	if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
	}
	if($_GET['page']=='ultimate-taxonomy-manager' || $_POST['page']=='ultimate-taxonomy-manager')
		{
		

			if($_GET['sub']=='custom-taxonomy' ||$_POST['sub']=='custom-taxonomy')
			{
                
				xy_wrapper();
				
			}elseif($_GET['sub']=='custom-taxonomy-fields' || $_POST['sub']=='custom-taxonomy-fields')
			{
				xydac_tax();
			}else
			{

                xydac_home();
				//home
			}
		}
}

//---create-taxonomies page
function xydac_singular($name)
{return ((substr($name,-1)=='s') ? substr($name,0,-1) : $name);}

function xydac_meta_handler($post,$tax) {
    $xy_terms = get_terms($tax[args], 'hide_empty=0');
    $val = wp_get_object_terms($post->ID, $tax[args]);
    ?>
    <select name='<?php _e($tax[args],'xydac'); ?>' id='<?php _e($tax[args],'xydac'); ?>' style="width:95% ">
            <option class='<?php _e($tax[args],'xydac'); ?>-option' value='' <?php if (!count($val)) echo "selected";?>>None</option>
            <?php
        foreach ($xy_terms as $xy_term) {
            if (!is_wp_error($val) && !strcmp($xy_term->slug, $val[0]->slug) && !empty($val) )
                echo "<option class='"._e($tax[args],'xydac')."-options' value='" . $xy_term->slug . "' selected>" . $xy_term->name . "</option>\n";
            else
                echo "<option class='"._e($tax[args],'xydac')."-options' value='" . $xy_term->slug . "'>" . $xy_term->name . "</option>\n";
        }
    ?>
    </select>
    <?php
}
function xydac_meta_boxes(){
    
    $taxonomies = get_option("xydac_taxonomies");
        if (is_array($taxonomies) && !empty($taxonomies))
        foreach ($taxonomies  as $taxonomy )
        {

        if($taxonomy[showascombobox]=='true')
        {
            if($taxonomy['args']['hierarchical'])
                {
                    foreach($taxonomy['object_type'] as $a)
                        remove_meta_box($taxonomy['name'].'div',$a,'core');
                }
                else
                {
                    foreach($taxonomy['object_type'] as $a)
                        remove_meta_box('tagsdiv-'.$taxonomy['name'],$a,'core');
                }
                foreach($taxonomy['object_type'] as $a)
                {add_meta_box($taxonomy['name'].'_box', __($taxonomy['args']['label']), 'xydac_meta_handler', $a, 'side', 'low', $taxonomy['name']);}
        }
        }
}

function xydac_reg_taxonomies(){
    $taxonomies = get_option("xydac_taxonomies");
    
    if (is_array($taxonomies) && !empty($taxonomies))
        foreach ($taxonomies  as $taxonomy )
        {
            
            $xy_tax['name']= $taxonomy['name'];
            $xy_tax['object_type']= $taxonomy['object_type'];
            $xy_tax['args']['labels']['name'] = ( !empty($taxonomy['args']['labels']['name']) ) ? $taxonomy['args']['labels']['name'] : ( (!empty($taxonomy['args']['label'])) ? $taxonomy['args']['label'] : $taxonomy['args']['name']);
                $xy_sname = xydac_singular($xy_tax['name']);
                $xy_slabel = xydac_singular($xy_tax['args']['labels']['name']);
            $xy_tax['args']['labels']['singular_name'] = ( !empty($taxonomy['args']['labels']["singular_label"]) ? $taxonomy['args']['labels']["singular_label"] : $xy_sname);
            $xy_tax['args']['labels']['search_items'] = ( !empty($taxonomy['args']['labels']["search_items"]) ) ? $taxonomy['args']['labels']["search_items"] : 'Search ' .$taxonomy['args']['label'];
            $xy_tax['args']['labels']['popular_items'] = ( !empty($taxonomy['args']['labels']["popular_items"]) ) ? $taxonomy['args']['labels']["popular_items"] : 'Popular ' .$taxonomy['args']['label'];
            $xy_tax['args']['labels']['all_items'] = ( !empty($taxonomy['args']['labels']["all_items"]) ) ? $taxonomy['args']['labels']["all_items"] : 'All ' .$taxonomy['args']['label'];
            $xy_tax['args']['labels']['parent_item'] = ( !empty($taxonomy['args']['labels']["parent_item"]) ) ? $taxonomy['args']['labels']["parent_item"] : 'Parent ' .$xy_slabel;
            $xy_tax['args']['labels']['parent_item_colon'] = ( !empty($taxonomy['args']['labels']["parent_item_colon"]) ) ? $taxonomy['args']['labels']["parent_item_colon"] : 'Parent '.$xy_slabel.':';
            $xy_tax['args']['labels']['edit_item'] = ( !empty($taxonomy['args']['labels']["edit_item"]) ) ? $taxonomy['args']['labels']["edit_item"] : 'Edit ' .$xy_slabel;
            $xy_tax['args']['labels']['update_item'] = ( !empty($taxonomy['args']['labels']["update_item"]) ) ? $taxonomy['args']['labels']["update_item"] : 'Update ' .$xy_slabel;
            $xy_tax['args']['labels']['add_new_item'] = ( !empty($taxonomy['args']['labels']["add_new_item"]) ) ? $taxonomy['args']['labels']["add_new_item"] : 'Add New ' .$xy_slabel;
            $xy_tax['args']['labels']['new_item_name'] = ( !empty($taxonomy['args']['labels']["new_item_name"]) ) ? $taxonomy['args']['labels']["new_item_name"] : 'New ' .$xy_slabel. ' Name';
            $xy_tax['args']['labels']['separate_items_with_commas'] = ( !empty($taxonomy['args']['labels']["separate_items_with_commas"]) ) ? $taxonomy['args']['labels']["separate_items_with_commas"] : 'Separate ' .$taxonomy['args']['label']. ' with commas';
            $xy_tax['args']['labels']['add_or_remove_items'] = ( !empty($taxonomy['args']['labels']["add_or_remove_items"]) ) ? $taxonomy['args']['labels']["add_or_remove_items"] : 'Add or remove ' .$taxonomy['args']['label'];
            $xy_tax['args']['labels']['choose_from_most_used'] = ( !empty($taxonomy['args']['labels']["choose_from_most_used"]) ) ? $taxonomy['args']['labels']["choose_from_most_used"] : 'Choose from the most used ' .$taxonomy['args']['label'];
            $xy_tax['args']['label'] = $xy_tax['args']['labels']['name'];
            $xy_tax['args']['public']= $taxonomy['args']['public'];
            $xy_tax['args']['show_in_nav_menus']= $taxonomy['args']['show_in_nav_menus'];
            $xy_tax['args']['show_ui']= $taxonomy['args']['show_ui'];
            $xy_tax['args']['show_tagcloud']= $taxonomy['args']['show_tagcloud'];
            $xy_tax['args']['hierarchical']= $taxonomy['args']['hierarchical'];
            $xy_tax['args']['rewrite']= $taxonomy['args']['rewrite']['val'];
            if(!$xy_tax['args']['rewrite']){
            $xy_tax['args']['rewrite']['slug']= $taxonomy['args']['rewrite']['slug'];
            $xy_tax['args']['rewrite']['with_front']= $taxonomy['args']['rewrite']['with_front'];}
            $xy_tax['args']['query_var']= ( !empty($taxonomy['args']['query_var']) ? $taxonomy['args']['query_var'] : $taxonomy['name']);

            register_taxonomy($xy_tax['name'],$xy_tax['object_type'],$xy_tax['args']);
            //----




        }

}

?>